// AFSK2APRS_DRA_1448 

// version for receiving only 
#include <LibAPRS.h>
//#define ADC_REFERENCE REF_3V3
#define ADC_REFERENCE REF_5V // use also for ALL versions of "PRO MINI's" )  
#define OPEN_SQUELCH false   // open

#include <SoftwareSerial.h> 
SoftwareSerial ss(12, 8 );               // RX, TX
int ledPin = 13;        

// set parameters for DRA818V on 144.8 MHz
int bw = 0;                              // bandwith in KHz ( 0 = 12.5 or 1 = 25 )
double ftx = 144.8000;                   // tx frequency in MHz (134.0000 - 174.0000)
double frx = 144.8000;                   // rx frequency in MHz (134.0000 - 174.0000) 
String tx_ctcss = "0000";                // ctcss frequency ( 0000 - 0038 ); 0000 = "no CTCSS"  
String rx_ctcss = "0000";                // ctcss frequency ( 0000 - 0038 ); 0000 = "no CTCSS"  
int squ = 0;                             // squelch level  ( 0 - 8 ); 0 = "open"  

/////////////////////////////////////////////////////////////
boolean gotPacket = false;
AX25Msg incomingPacket;
uint8_t *packetData;

////////////////////////////////////////////////////////////
void aprs_msg_callback(struct AX25Msg *msg) 
{
  if (!gotPacket) {
    gotPacket = true;
    memcpy(&incomingPacket, msg, sizeof(AX25Msg));
  if (freeMemory() > msg->len) {
      packetData = (uint8_t*)malloc(msg->len);
      memcpy(packetData, msg->info, msg->len);
      incomingPacket.info = packetData;
    } else {
      gotPacket = false;
    }
  }
}

/////////////////////////////////////////////////////////////
void setup() 
{
  pinMode(ledPin, OUTPUT);     
  ss.begin(9600);                    // open serial at 9600 bps
  delay(1000);
  ss.print("AT+DMOSETGROUP=");       
  ss.print(bw);
  ss.print(",");
  ss.print(ftx,4); 
  ss.print(",");
  ss.print(frx,4);
  ss.print(",");
  ss.print(tx_ctcss);
  ss.print(",");
  ss.print(squ);
  ss.print(",");
  ss.println(rx_ctcss);
  delay(1000);
  //ss.println("AT+SETFILTER=1,0,0");    // no Deemphasis       
  //delay(1000);
  
  digitalWrite(ledPin, HIGH);
  delay(200);
  digitalWrite(ledPin, LOW);
  delay(200);
  digitalWrite(ledPin, HIGH);
  delay(200);
  digitalWrite(ledPin, LOW);
  delay(200);
  
  Serial.begin(9600);
  Serial.print("RX-Frq: ");
  Serial.print(frx,4);
  Serial.println(" MHz");  
  delay(200);
  APRS_init(ADC_REFERENCE, OPEN_SQUELCH);
}

///////////////////////////////////////////////////////////////
void processPacket() {
  if (gotPacket) {
    digitalWrite(ledPin, HIGH);
    gotPacket = false;    
//   Serial.println(" ");    
    Serial.print(incomingPacket.src.call);             // sender callsign
    if (incomingPacket.src.ssid>0)
  { Serial.print(F("-"));
    Serial.print(incomingPacket.src.ssid); }           // SSID
    Serial.print(">");                                 // > 
    Serial.print(incomingPacket.dst.call);             // address callsign or MIC-E data
    Serial.print(":");                                 // : 
    for (int i = 0; i < incomingPacket.len; i++) {  
    Serial.write(incomingPacket.info[i]);              // data contents
    }
    Serial.println(" ");                               // CR/LF            
    free(packetData);
    delay(200);    
    digitalWrite(ledPin, LOW);
    delay(200);
  }
}

/////////////////////////////////////////////////////////////
void loop() 
{
  processPacket();
}

